var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _BackDropContext_instances, _BackDropContext_canvas, _BackDropContext_ctx, _BackDropContext_id, _BackDropContext_updateView, _BackDropContext_delay, _BackDropContext_timeout, _BackDropContext_updateCanvasDimensions, _BackDropContext_onResize;
class BackDropContext {
    constructor(updateView, delay = 0) {
        _BackDropContext_instances.add(this);
        _BackDropContext_canvas.set(this, void 0);
        _BackDropContext_ctx.set(this, void 0);
        _BackDropContext_id.set(this, void 0);
        _BackDropContext_updateView.set(this, void 0);
        _BackDropContext_delay.set(this, void 0);
        _BackDropContext_timeout.set(this, void 0);
        __classPrivateFieldSet(this, _BackDropContext_id, `__dropback_${Date.now()}`, "f");
        __classPrivateFieldSet(this, _BackDropContext_delay, delay, "f");
        __classPrivateFieldSet(this, _BackDropContext_updateView, updateView, "f");
    }
    show() {
        __classPrivateFieldSet(this, _BackDropContext_canvas, document.createElement('canvas'), "f");
        __classPrivateFieldGet(this, _BackDropContext_canvas, "f").id = __classPrivateFieldGet(this, _BackDropContext_id, "f");
        __classPrivateFieldGet(this, _BackDropContext_canvas, "f").style.position = 'absolute';
        __classPrivateFieldGet(this, _BackDropContext_canvas, "f").style.top = '0';
        __classPrivateFieldGet(this, _BackDropContext_canvas, "f").style.left = '0';
        __classPrivateFieldGet(this, _BackDropContext_canvas, "f").style.zIndex = '99999';
        __classPrivateFieldGet(this, _BackDropContext_instances, "m", _BackDropContext_updateCanvasDimensions).call(this);
        __classPrivateFieldSet(this, _BackDropContext_ctx, __classPrivateFieldGet(this, _BackDropContext_canvas, "f").getContext('2d'), "f");
        document.body.append(__classPrivateFieldGet(this, _BackDropContext_canvas, "f"));
        window.addEventListener('resize', __classPrivateFieldGet(this, _BackDropContext_instances, "m", _BackDropContext_onResize).bind(this));
    }
    hide() {
        document.getElementById(__classPrivateFieldGet(this, _BackDropContext_id, "f")).remove();
        window.removeEventListener('resize', __classPrivateFieldGet(this, _BackDropContext_instances, "m", _BackDropContext_onResize).bind(this));
    }
    getCtx() {
        return __classPrivateFieldGet(this, _BackDropContext_ctx, "f");
    }
    getWidth() {
        return __classPrivateFieldGet(this, _BackDropContext_canvas, "f").width;
    }
    getHeight() {
        return __classPrivateFieldGet(this, _BackDropContext_canvas, "f").height;
    }
}
_BackDropContext_canvas = new WeakMap(), _BackDropContext_ctx = new WeakMap(), _BackDropContext_id = new WeakMap(), _BackDropContext_updateView = new WeakMap(), _BackDropContext_delay = new WeakMap(), _BackDropContext_timeout = new WeakMap(), _BackDropContext_instances = new WeakSet(), _BackDropContext_updateCanvasDimensions = function _BackDropContext_updateCanvasDimensions() {
    __classPrivateFieldGet(this, _BackDropContext_canvas, "f").width = window.innerWidth;
    __classPrivateFieldGet(this, _BackDropContext_canvas, "f").height = Math.max(window.innerHeight, document.body.scrollHeight, document.documentElement?.scrollHeight);
}, _BackDropContext_onResize = function _BackDropContext_onResize() {
    window.clearTimeout(__classPrivateFieldGet(this, _BackDropContext_timeout, "f"));
    __classPrivateFieldSet(this, _BackDropContext_timeout, window.setTimeout(() => {
        __classPrivateFieldGet(this, _BackDropContext_instances, "m", _BackDropContext_updateCanvasDimensions).call(this);
        __classPrivateFieldGet(this, _BackDropContext_updateView, "f").call(this);
    }, __classPrivateFieldGet(this, _BackDropContext_delay, "f")), "f");
};
export default BackDropContext;
//# sourceMappingURL=BackDropContext.js.map